.\"	$NetBSD: supservers.8,v 1.9 2002/02/08 01:38:56 ross Exp $
.\"
.\" Copyright (c) 1992 Carnegie Mellon University
.\" All Rights Reserved.
.\"
.\" Permission to use, copy, modify and distribute this software and its
.\" documentation is hereby granted, provided that both the copyright
.\" notice and this permission notice appear in all copies of the
.\" software, derivative works or modified versions, and any portions
.\" thereof, and that both notices appear in supporting documentation.
.\"
.\" CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
.\" CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
.\"
.\" Carnegie Mellon requests users of this software to return to
.\"
.\"  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
.\"  School of Computer Science
.\"  Carnegie Mellon University
.\"  Pittsburgh PA 15213-3890
.\"
.\" any improvements or extensions that they make and grant Carnegie Mellon
.\" the rights to redistribute these changes.
.\"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
.\" HISTORY
.\" Revision 1.3  92/08/11  12:08:50  mrt
.\" 	Documented -C switch
.\" 	[92/08/11            mrt]
.\"
.TH SUPSERVERS 8 1/16/86
.SH "NAME"
supfilesrv, supscan \- sup server processes
.SH "SYNOPSIS"
supfilesrv
[
.I
-4
] [
.I
-6
] [
.I
-d
] [
.I
-l
] [
.I
-q
] [
.I
-N
] [
.I
-P
] [
.I -C MaxChildren
]
.br
supscan [
.I
-v
] [
.I
-s
] [
.I
collection
] [
.I
basedir
]
.SH "DESCRIPTION"
.I
Supfilesrv
is the server processes used to interact with
.I
sup
client processes via the IP/TCP network protocol.
This server
normally is expected to be running on server machines at all times.
Each machine with files of interest to users on other machines is
expected to be a file server and should run
.I
supfilesrv.

A file server machine will service requests for both "private" and
"system" file collections.
No special action is necessary to support
private collections, as the client user is expected to supply all
necessary information.
For system collections, if the base directory
is not the default (see FILES below), an entry must be put into
the directory list file; this entry is a single text line containing
the name of the collection, one or more spaces, and the name of the
base directory for that collection.

Each collection should have
an entry in the host list file; this entry is a single text line
containing the name of the collection, one or more spaces, and
the name of the host machine acting as file server for that collection.

Details of setting up a file collection for the file server are
described in the manual entry for
.I
sup(1).

.I
Supfilesrv
generally runs as a network server process that listens for connections,
and for each connection (double-)forks a process to handle the interaction
with the client.
However, with the -d flag, no forking will take place:
the server will listen for a network connection, handle it, and exit.
This is useful for debugging the servers in "live" mode rather than as
daemons.

For debugging purposes, the -P "debugging ports" flag can be used.
It will cause the selection of an alternate, non-privileged set of
TCP ports instead of the usual ports, which are reserved for the
active server processes.  The -N "network debugging" flag can be used
to produce voluminous messages describing the network communication
progress and status. The more -N switches that you use the more output
you get. Use 3 (separated by spaces: -N -N -N) to get a complete record
of all network messages. Log messages are printed by
.I syslog
on
.I daemon.log .
To suppress
log messages, the -q "quiet" flag can be used.

.I supfilesrv
uses libwrap style access control (the /etc/hosts.allow and /etc/hosts.deny
files) with service name "supfilesrv". The -l "log" flag turn on loggin of
accepted connections (denied connections are always logged).

Normally the
.I supfilesrv
will only respond to 3 requests simultaneously, forking a child
process for each client. If it gets additional requests it will respond
with the error FSSETUPBUSY. The -C MaxChildren switch can be used
to increase (or decrease) this number.

.I supfilesrv
listens to IPv4 listening socket by default.
With the -6 flag, it will listen to IPv6 listening socket.
For dual stack support you will want to run two instances of
.I supfilesrv.

.SH "SUPSCAN"
It is possible to pre-compile a list of the files in a collection
to make
.I
supfilesrv
service that collection much faster.  This can be done by running
.I
supscan
on the desired collection on the repository machine.  This produces a
list of all the files in the collection at the time of the
.I
supscan;
subsequent upgrades will be based on this list of files rather than
actually scanning the disk at the time of the upgrade.  Of course,
the upgrade will consequently bring the client machine up to the status
of the repository machine as of the time of the
.I
supscan
rather than as of the time of the upgrade; hence, if
.I
supscan
is used, it should be run periodically on the
collection.
This facility is useful for extremely large file collections
that are upgraded many times per day, such as the CMU UNIX system
software.  The "verbose" flag
.I
-v
will cause
.I
supscan
to produce output messages as it scans the files in the collection.
The "system" flag
.I
-s
will cause
.I
supscan
to scan all system collections residing on the current host.
The
.I
basedir
parameter must be specified if the collection is a private
collection whose base directory is not the default.
.SH "FILES"
.TP
/usr
default base directory for a collection
.TP
/etc/supfiles/coll.dir
base directory list for system collections
.TP
/etc/supfiles/coll.host
host name list for system collections
.TP
\*[Lt]base-directory\*[Gt]/sup/\*[Lt]collection\*[Gt]/*
files used by file server (see
.I
sup(1))
.TP
\*[Lt]base-directory\*[Gt]/sup/\*[Lt]collection\*[Gt]/list
list file used by
.I
supscan
to create file list
.TP
\*[Lt]base-directory\*[Gt]/sup/\*[Lt]collection\*[Gt]/scan
file list created by
.I
supscan
from list file
.DT
.PP
.SH "SEE ALSO"
sup(1)
hosts_access(5)
hosts_options(5)
.br
.I
The SUP Software Upgrade Protocol,
S.
A.
Shafer, CMU Computer Science Dept., 1985.
.SH "DIAGNOSTICS"
The file server places log messages on the
standard and diagnostic output files.
The process name and process
id number generally accompany each message for diagnostic purposes.
.SH "HISTORY"
.TP
31-July-92 Mary Thompson (mrt) at Carnegie Mellon University
Removed references to supnameserver which has not existed for
a long time. Update a few file names. Added -C switch.
.TP
21-May-87  Glenn Marcy (gm0w) at Carnegie-Mellon University
Updated documentation for 4.3; changed /usr/cmu to /usr/cs.
.TP
15-Jan-86  Glenn Marcy (gm0w) at Carnegie-Mellon University
Updated documentation; -s switch to supscan.
.TP
23-May-85  Steven Shafer (sas) at Carnegie-Mellon University
Supscan created and documented; also -N flag.
.TP
04-Apr-85  Steven Shafer (sas) at Carnegie-Mellon University
Created.
